<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.meludi");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final Formatter dateFormat = new DateFormatter("yyyyMMdd");
%>
<base:page type="default" >
<base:head 
	scripts="~../meludi-2.js,~extraction_preparation.js" 
	styles="path.css,~../css/meludi-2.css"
	>
<style>
tr.highlight
{
	border-top-width: 1px;
	border-top-style: dotted;
}

#detailsTable
{
	width: 100%; 
	border-collapse: collapse;
	border-bottom-width: 1px;
	border-top-width: 1px;
}

#detailsTable td, #detailsTable th
{
	text-align: center;
	min-width: 5%;
	padding-top: 1px;
	padding-bottom: 1px;
}

#detailsTable .comment
{
	min-width: 10%;
}

#detailsTable .italic
{
	font-style: italic;
}

.nondefault
{
	background: #FFF066;
}
.nondefault:after
{
	content: '›';
}
.nondefault:before
{
	content: '‹';
}
span.status
{
	width: 20px;
	float: right;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="MeLuDi" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Lab tracking protocol for Allprep isolation" 
		/></p:path>

	<div class="content">

	<form name="meludi" action="extraction_protocol2.jsp" method="post" target="_blank" id="wizard" class="wizard">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="hiddenSubmitInfo" value="">
		<input type="hidden" name="hiddenNumItems" value="">
		<input type="hidden" name="hiddenCounterBalanceInfoRow" value="">
		<select type="hidden" name="extraQiacubeItems" id="extraQiacubeItems" multiple></select>

	<div class="step auto-hide" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select unprocessed extract source items</div>
		<div class="step-content">
	
			<table class="step-form">
			<tr class="align-top">
				<td class="prompt">Specimens/RNA/DNA</td>
				<td class="input">
					<select name="extractSourceItems" id="extractSourceItems" multiple size="30"></select>
				</td>
				<td class="status" id="extractSourceItems.status"></td>
				<td class="help">
					<span id="extractSourceItems.message" class="message" ></span>
					Select 1-24 items. If the number is <= 12, locations will be reserved
					in a single QIAcube, otherwise two. If 1 or 11 items are reserved for a QIAcube,
					a counterbalance blank vial filled with water must be added, to ensure balance.
					The list contains unprocessed specimen and unquantified RNA/DNA items.
				</td>
			</tr>
			<tr>
				<td class="prompt">Number of extra QIAcube samples</td>
				<td class="input">
					<input type="text" name="numExtraQiacubeItems" id="numExtraQiacubeItems"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus=""
						style="width: 8em;" maxlength="10" value="1">
				</td>
				<td class="status" id="numExtraQiacubeItems.status"></td>
				<td class="help"><span id="numExtraQiacubeItems.message" class="message"></span>
					 Number of extra QIAcube items, outside MeLuDi project.
					 The number of extra items is limited to 24 - number of selected MeLuDi items.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<!-- 2. Extraction + QIAcube information -->
	<div class="step auto-hide" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">Common information for Extraction and QIAcube step</div>
		<div class="step-content">
		
			<table class="step-form">
			<tbody class="section-header">
				<tr>
					<td colspan="4">Extraction</td>
				</tr>
			</tbody>
			<tr>
				<td class="prompt">Start plate name</td>
				<td class="input">
					<input type="text" name="startPlateName" id="startPlateName" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="extractionDate"
						value="<%=HTML.encodeTags(user.getName()) %>" maxlength="255">
				</td>
				<td class="status" id="startPlateName.status"></td>
				<td class="help">
					<span id="startPlateName.message" class="message">DNA plate used for this batch of extract source items.</span>
					DNA reaction plate for this batch of extract source items
				</td>
			</tr>
			<tr>
				<td class="prompt">Isolation date</td>
				<td class="input">
					<input type="text" name="isolationDate" id="isolationDate"
						value="<%=dateFormat.format(new Date()) %>" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="extractionProtocol"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="isolationDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="isolationDate"
							data-date-format="yyyyMMdd"
							data-title="Isolation date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="isolationDate.status"></td>
				<td class="help">
					<span id="isolationDate.message" class="message"></span>
					(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td class="input">
					<select name="extractionProtocol" id="extractionProtocol" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qiacubeDate"
					></select>
				</td>
				<td class="status" id="extractionProtocol.status"></td>
				<td class="help">
					<span id="extractionProtocol.message" class="message"></span>
					Select the protocol which was used in the extraction step.
				</td>
			</tr>
			<tr>
<!--
			<tr>
				<td class="prompt">RNA default volume (µl)</td>
				<td class="input">
					<input type="text" name="rnaDefaultVolume" id="rnaDefaultVolume" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="dnaDefaultVolume"
						maxlength="255">
				</td>
				<td class="status" id="rnaDefaultVolume.status"></td>
				<td class="help">
					<span id="rnaDefaultVolume.message" class="message"></span>
					Default RNA elution volume.
				</td>
			</tr>
			<tr>
				<td class="prompt">DNA default volume (µl)</td>
				<td class="input">
					<input type="text" name="dnaDefaultVolume" id="dnaDefaultVolume" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qiacubeDate"
						maxlength="255">
				</td>
				<td class="status" id="dnaDefaultVolume.status"></td>
				<td class="help">
					<span id="dnaDefaultVolume.message" class="message"></span>
					Default DNA elution volume.
				</td>
			</tr>
-->
			<tbody class="section-header">
				<tr>
					<td colspan="4">QIAcube</td>
				</tr>
			</tbody>
			<tr>
				<td class="prompt">Date</td>
				<td class="input">
					<input type="text" name="qiacubeDate" id="qiacubeDate"
						value="<%=dateFormat.format(new Date()) %>" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qiacubePrimaryPrefix"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="qiacubeDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="qiacubeDate"
							data-date-format="yyyyMMdd"
							data-title="Qiacube date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="qiacubeDate.status"></td>
				<td class="help">
					<span id="qiacubeDate.message" class="message"></span>
					(YYYYMMDD or MMDD) Used in names of sample id files
				</td>
			</tr>
			<tr>
				<td class="prompt">Primary QIAcube prefix</td>
				<td class="input">
					<select name="qiacubePrimaryPrefix" id="qiacubePrimaryPrefix"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qiacubeSecondaryPrefix">
						<option value="A">A
						<option selected value="B">B
						<option value="C">C
						<option value="D">D
						<option value="E">E
						<option value="F">F
						<option value="G">G
						<option value="H">H
						<option value="I">I
						<option value="J">J
						<option value="K">K
						<option value="L">L
						<option value="M">M
						<option value="N">N
						<option value="O">O
						<option value="P">P
						<option value="Q">Q
						<option value="R">R
						<option value="S">S
						<option value="T">T
						<option value="U">U
						<option value="V">V
						<option value="W">W
						<option value="X">X
						<option value="Y">Y
						<option value="Z">Z
					</select>
				</td>
				<td class="status" id="qiacubePrimaryPrefix.status"></td>
				<td class="help">
					<span id="qiacubePrimaryPrefix.message" class="message"></span>
					Prefix for primary QIAcube.
				</td>
			</tr>
			<tr>
				<td class="prompt">Secondary QIAcube prefix</td>
				<td class="input">
					<select name="qiacubeSecondaryPrefix" id="qiacubeSecondaryPrefix"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qiacubeRunNo">
						<option value="A">A
						<option value="B">B
						<option selected value="C">C
						<option value="D">D
						<option value="E">E
						<option value="F">F
						<option value="G">G
						<option value="H">H
						<option value="I">I
						<option value="J">J
						<option value="K">K
						<option value="L">L
						<option value="M">M
						<option value="N">N
						<option value="O">O
						<option value="P">P
						<option value="Q">Q
						<option value="R">R
						<option value="S">S
						<option value="T">T
						<option value="U">U
						<option value="V">V
						<option value="W">W
						<option value="X">X
						<option value="Y">Y
						<option value="Z">Z
					</select>
				</td>
				<td class="status" id="qiacubeSecondaryPrefix.status"></td>
				<td class="help">
					<span id="qiacubeSecondaryPrefix.message" class="message"></span>
					Prefix for secondary QIAcube (if needed).
				</td>
			</tr>
			<tr>
				<td class="prompt">Run number</td>
				<td class="input">
					<input type="text" name="qiacubeRunNo" id="qiacubeRunNo"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qiacubeOperator"
						style="width: 8em;" maxlength="10" value="1">
				</td>
				<td class="status" id="qiacubeRunNo.status"></td>
				<td class="help"><span id="qiacubeRunNo.message" class="message"></span>
					 Used in names of sample id files
				</td>
			</tr>
			<tr>
				<td class="prompt">Operator</td>
				<td class="input">
					<input type="text" name="qiacubeOperator" id="qiacubeOperator" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="allPrepFfpeKit"
						value="<%=HTML.encodeTags(user.getName()) %>" maxlength="255">
				</td>
				<td class="status" id="qiacubeOperator.status"></td>
				<td class="help">
					<span id="qiacubeOperator.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="prompt" id="allPrepFfpeKit.title">AllPrep DNA/RNA FFPE kit</td>
				<td class="input">
					<input type="text" name="allPrepFfpeKit" id="allPrepFfpeKit" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus=""
						maxlength="255">
				</td>
				<td class="status" id="allPrepFfpeKit.status"></td>
				<td class="help">
					<span id="allPrepFfpeKit.message" class="message"></span>
					Lot numbers for the reagents used.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<!-- 3. DNA/RNA information -->
	<div class="step" id="step-3">
		<div class="step-no">3</div>
		<div class="step-title">RNA/DNA details</div>
		<div class="step-content">

<!--		
			<div class="bg-filled-50" style="padding: 2px;">
				The table below show values from the QIAcube run.
				<span class="nondefault">Highlighted</span> values have been manually 
				changed from their default values. If the QIAcube positions are not correct,
				they must be fixed before the <i>NanoDrop Sample ID</i> file is downloaded
				since the order in this file depends on the positions. The concentrations
				and other values are loaded from the file after the NanoDrop has been completed.
			</div>
-->
			<div class="bg-filled-50" id="detailsStartPlateName" style="padding: 2px;"></div>
			<div class="bg-filled-50" style="padding: 2px;">
				1. Check QIAcube positions (instrument prefix ID ['A'-'Z'] + position [1-12], e.g. "B3") and edit if necessary.<br>
				2. Download NanoDrop sample ID file for import by NanoDrop software.<br>
				3. Download qPCR sample ID file for import by qPCR software.<br>
				4. Create lab tracking sheet (opens in new tab/window).<br>
				5. Important! If you want to import DNA concentration values from a Qubit value file, the items must be measured in exactly the same order, as in the lab tracking sheet.<br>
				6. If everything is OK, click "Register" to register the new DNA start plate.<br>
				<br>
				<span class="nondefault">Highlighted</span> values in the table below have been manually 
				changed from their default values. If the QIAcube positions are not correct,
				they must be fixed before the <i>NanoDrop Sample ID</i> file is downloaded
				since the order in this file depends on the positions. The concentrations
				and other values are loaded in the next wizard after the NanoDrop, qPCR, and Qubit
				runs/measurements have been completed.
			</div>

			<div id="detailsSection"></div>

			<table class="step-form">
			<tr class="align-top">
				<td class="prompt">NanoDrop Sample ID</td>
				<td class="input">
					<base:button id="downloadSampleIdFile" title="Download..."
						image="<%=home + "/images/download.png"%>" style="width:10em;" />
					<label><input type="checkbox" name="blankControlColumn" id="blankControlColumn" value="true" checked>Column with blank controls</label>
				</td>
				<td class="status" id="downloadSampleIdFile.status"></td>
				<td class="help">
					<span id="downloadSampleIdFile.message" class="message"></span>
					Download and import this file to the NanoDrop software before analyzing the RNA.
					<b>Note that the samples are sorted by QIAcube position!</b>
				</td>
			</tr>
			<tr>
				<td class="prompt">qPCR Sample ID</td>
				<td class="input">
					<base:button id="downloadQPcrSampleIdFile" title="Download..."
						image="<%=home + "/images/download.png"%>" style="width:10em;" />
				</td>
				<td class="status" id="downloadQPcrSampleIdFile.status"></td>
				<td class="help">
					<span id="downloadQPcrSampleIdFile.message" class="message"></span>
					Download and import this file to the qPCR software before analyzing the DNA.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
<!--
		<td><base:button id="goregister" title="Register start plate" image="<%=home+"/images/import.png"%>"  /></td>
-->
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td><base:button id="gocreate" title="Create lab tracking sheet" image="<%=home+"/images/import.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	
	<div id="debug-tools">
	</div>
	
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>